//--------------------------------------------------------------------------------
//  OpenGL Wrapping Class (GL::CSolidModel)
//    Copyright  (C)  2005  kei mesuda  
//    (http://www.yomogi.sakura.ne.jp/~si)
//--------------------------------------------------------------------------------
//  GL::CSolidModel   
//  Œ Model NXD{Iɂ Metasequoia  DisplayList bvD
//  T|[g  G@vZCޗǗC_FCUVMapCX[XVFCfBO(\)
//  T|[gG_(Ɨ_), , 4_ʂ̕ۑ(3_ɕĕۑ)
//  \G CSolidModel { MATERIAL_DATA, OBJECT_DATA { VERTEX_DATA, FACE_DATA }; };
//  1. Load()  Metasequoia Object File ̓ǂ߂镔Ǎ(4_ʂ3_ɕ)
//  2.1 Compile() -> CallList() ŁCTextureo^ -> DisplayList 쐬 -> DisplayList `
//  2.2 RegisterTexture() -> Draw() ŁCTextureo^ -> `
//  2.3 DrawSolid() ŁC}eA𖳎Č`̂ݕ`
//  
//  1. SetTextureManager() ŊÕeNX`}l[W֘AtiʏftHgjD
//  2. AllocObject() ŃIuWFNg̊mہiAllocȂꍇLoad()ŏɊmۂj
//  3. LoadBinary() ŃIWioCif[^Ǎ
//  4. Save() ŃIWioCif[^ۑ
//  5. MakeArray()  InterleavedArrays(GL_TRIANGLES) ɕϊD
//
//--------------------------------------------------------------------------------
// GL::CompileModel()
// Metasequoia Model Object File  OpenGL Display List 𐶐 ID ԂD
//--------------------------------------------------------------------------------

#ifndef _CORE_GLSOLIDMODEL_INCLUDED
#define _CORE_GLSOLIDMODEL_INCLUDED

#include "SimpleScript.h"
#include "GLMaterial.h"
#include "GLArray.h"
#include "GLElement.h"
#include "GLLight.h"
#pragma message ("<< CORE_MESSAGE >>  include GL::CSolidModel")

namespace GL {
class CSolidModel
{
//--------------------------------------------------
// \
//--------------------------------------------------
public:
    // Vertex \
    struct VERTEX_DATA {
        CVector vc;                             // _
        DWORD   col;                            // _F
    };

    // Face \
    struct FACE_DATA {
        char        mat;                        // }eAԍ(-1 ŕWF)
        WORD        idx[3];                     // _CfbNX
        VECTOR2D    uv[3];                      // eNX`W
        // ȉL^ȂDf̓xɌvZ 
        CVector     vcFaceNormal;               // ʖ@f[^
        CVector     vcVertexNormal[3];          // _@f[^
    };

    // Object \
    class OBJECT_DATA {
    public:
        std::string              strName;       // IuWFNg
        std::vector<VERTEX_DATA> aVertex;       // _f[^
        std::vector<FACE_DATA>   aFace;         // ʃf[^
        float                    fFacet;        // Smoothing Angle [rad]
        DWORD                    dwColor;       // F
        // ȉL^ȂDf̓xɌvZ
        CVector                  vcMinimum;     // IuWFNg\钸_ x,y,z ŏl
        CVector                  vcMaximum;     // IuWFNg\钸_ x,y,z ől

        OBJECT_DATA()
        {
            fFacet = 0.0f;
            dwColor = 0xffffffff;
        }

        ~OBJECT_DATA()
        {
        }
    };

    // Material \
    class MATERIAL_DATA {
    public:
        std::string              strName;        // }eA
        CMaterial                material;       // ޗp[^ 
        bool                     bVertexColor;   // _F̗p(0/1)
        
        MATERIAL_DATA()
        {
            bVertexColor = false;
        }
        
        ~MATERIAL_DATA()
        {
        }
    };

//--------------------------------------------------
// oϐ
//--------------------------------------------------
private:
    std::vector<MATERIAL_DATA> m_aMaterial;          // ޗf[^{
    std::vector<OBJECT_DATA>   m_aObject;            // IuWFNgf[^{

    GLuint                     m_uiID;               // DisplayList ID
    int                        m_iDisplayListCount;  // DisplayList Count
	CVector                    m_vcMinimum;          // _̍ŏl
	CVector                    m_vcMaximum;          // _̍ől

    CTextureManager*           m_pTextureManager;       // eNX`ǗNX̃|C^
    static CTextureManager     s_DefaultTextureManager; // LeNX`ǗCX^X

//--------------------------------------------------
// o֐
//--------------------------------------------------
public:
    // RXgN^
    CSolidModel();
    ~CSolidModel();

    // ݒ
    void  SetTextureManager(CTextureManager* ptm);      // OeNX`ǗCX^Xgp
    static CTextureManager* GetDefaultTextureManager(); // ftHgeNX`ǗCX^X̎擾

    // t@C
    bool  Load(char* strFileName);              // eLXgf[^CMetasequoia File ̓ǂ݂

    // 
    void  Free(bool bFreeList = true);                  // S̉ibFreeList = false  DisplayList͔jȂj
    void  RegisterTexture();                            // gpeNX`o^
    void  UnRegisterTexture();                          // gpeNX`̓o^𖕏
    void  MultMatrix(CMatrix &mat);                     // Wϊ
    void  MultMatrix(int iObjectIndex, CMatrix &mat);   // WϊiIuWFNgPʁj
    void  MultQuat(CVector &qt);                        // ]NH[^jIϊ
    void  MultQuat(int iObjectIndex, CVector &qt);      // ]NH[^jIϊiIuWFNgPʁj
    void  CalcFaceNormal();                             // @vZ
    void  CalcFaceNormal(int iObjectIndex);             // @vZiIuWFNgPʁj
	void  CalcVertexRange();                            // _݂͈̑͂vZ
	void  CalcVertexRange(int iObjectIndex);            // _݂͈̑͂vZiIuWFNgPʁj

    // `
    void  Draw(bool bSmooth=false);                     // fɕ`
    void  Draw(int iObjectIndex, bool bSmooth=false);   // fɕ`iIuWFNgPʁj
    void  DrawSolid();                                  // f`
    void  DrawSolid(int iObjectIndex);                  // f`iIuWFNgPʁj

    // fBXvCXg֘A
    GLuint Compile(bool bCompose=false, bool bSmooth=false);    // Display List ̍쐬, bCompose=false ŃIuWFNgPʂŕʂDisplay List
    void   FreeList();                                          // Display List ̔j
//  void   CallList();                                          // Compile() Ő Display List Ăяo 
//  void   CallList(int idx);                                   // Compile() Ő Display List ĂяoiCfbNXwj 

    // ϊ
    bool   MakeArray(int idxObject, CArray* pArray, bool bSmooth=false);    // CArray̍쐬iIuWFNgPʁj

// Ŏgp
private:
    // f[^ǂݍ 
    int   TextReadLine(Util::CSimpleScript* pscript);   // 󔒍sƃRgAEg΂ReadLine
    bool  TextSkipChunk(Util::CSimpleScript* pscript);  // ...} ΂

    bool  CheckHeader(Util::CSimpleScript* pscript);                                // wb_`FbN
    bool  ReadTextMaterialChunk(Util::CSimpleScript* pscript);                      // Material `Nǂ 
    bool  ReadTextMaterialData(MATERIAL_DATA* pMat, Util::CSimpleScript* pscript);  // Material f[^ǂ 
    bool  ReadTextObjectData(OBJECT_DATA* pObj, Util::CSimpleScript* pscript);      // Object f[^ǂ
    bool  ReadTextVertexData(OBJECT_DATA* pObj, Util::CSimpleScript* pscript);      // Vertex f[^ǂ
    bool  ReadTextFaceData  (OBJECT_DATA* pObj, Util::CSimpleScript* pscript);      // Face f[^ǂ
    int   ReadTextFaceLine(WORD* aInfo, WORD* aIndex, float* aUV, int iSize, Util::CSimpleScript* pscript);
    
    // `
    enum DRAWSUB_FUNC {
        DRAWSUB_NOFLAG        = 0x00,
        DRAWSUB_VERTEX_NORMAL = 0x01,
        DRAWSUB_TEXTURE_UV    = 0x02,
        DRAWSUB_FUNC_MAX   = 4
    };
    static void  (*(s_funcDrawSub[DRAWSUB_FUNC_MAX]))(OBJECT_DATA*, int&);  // `Tu[` Functor 
    static void  DrawSub(OBJECT_DATA* pObj, int &i);       // `Tu[`iʖ@C  UV}bvj 
    static void  DrawSubS(OBJECT_DATA* pObj, int &i);      // `Tu[`i_@CUV}bvj
    static void  DrawSubT(OBJECT_DATA* pObj, int &i);      // `Tu[`iʖ@C  UV}bvLj
    static void  DrawSubST(OBJECT_DATA* pObj, int &i);     // `Tu[`i_@CUV}bvLj
    DRAWSUB_FUNC DrawSubChangeMaterial(int idx);           // }eAւiԒl;eNX`QƁj

//--------------------------------------------------
// Q
//--------------------------------------------------
public:
    //  
    inline bool IsEmpty()
    {
        return m_aObject.empty();
    }

    // ܂܂IuWFNg̎Q
    inline int GetObjectCount()
    {
        return m_aObject.size();
    }

    // ܂܂}eA̎Q
    inline int GetMaterialCount()
    {
        return m_aMaterial.size();
    }

    // IuWFNgC̃CfbNXԂDreturn -1 ŃG[
    inline int GetIndex(char* strName)
    {
        int imax = GetObjectCount();
        for (int i=0; i<imax; i++) {
            if (m_aObject[i].strName.compare(strName) == 0) return i;
        }
        return -1;
    }

    // OɑΉ}eAԂDreturn NULL ŃG[
    inline CMaterial* GetMaterial(char* strName)
    {
        int imax = GetMaterialCount();
        for (int i=0; i<imax; i++) {
            if (m_aMaterial[i].strName.compare(strName) == 0) return &(m_aMaterial[i].material);
        }
        return NULL;
    }
    
    // CfbNXwŃ}eAԂD
    inline CMaterial* GetMaterial(int idx)
    {
        return (idx < m_aMaterial.size()) ? &(m_aMaterial[idx].material) : NULL;
    }

    // Compile() ō쐬Display List  ID Ԃ
    inline GLuint GetDisplayListID()
    {
        return m_uiID;
    }

    // Compile() ō쐬Display List   Ԃ
    inline int GetDisplayListCount()
    {
        return m_iDisplayListCount;
    }
    
    // Compile() Ő Display List Ăяo
    inline void CallList()
	{
    	for (int i=0; i<m_iDisplayListCount; i++) glCallList(m_uiID + i);
    }
    
    // Compile() Ő Display List ĂяoiCfbNXwj 
    inline void CallList(int idx)
	{
    	glCallList(m_uiID + idx);
    }

	// _̍ŏl
	inline CVector& GetVertexMin()
	{
		return m_vcMinimum;
	}

	inline CVector& GetVertexMin(int objidx)
	{
		return m_aObject[objidx].vcMinimum;
	}
	
	// _̍ől
	inline CVector& GetVertexMax()
	{
		return m_vcMaximum;
	}

	inline CVector& GetVertexMax(int objidx)
	{
		return m_aObject[objidx].vcMaximum;
	}
};



//--------------------------------------------------------------------------------
// GL::CompileModel()
//--------------------------------------------------------------------------------
// Metasequoia Model Object File  OpenGL Display List 𐶐D
//--------------------------------------------------------------------------------
inline GLint CompileModel(char* strFileName, bool bSmooth=false)
{
    CSolidModel model;
    GLint       dlidx;
    
    // fǂݍ
    if (!model.Load(strFileName)) return -1;

    // Display List 
    dlidx = glGenLists(1);
    if (dlidx == 0) return 0;
    glNewList(dlidx, GL_COMPILE);
        model.Draw(bSmooth);
    glEndList();

    return dlidx;
}

} // GL

#endif //_CORE_GLSOLIDMODEL_INCLUDED

