//--------------------------------------------------------------------------------
//  OpenGL Wrapping Class (GL::CTexture, GL::CTextureManager)
//    Copyright  (C)  2006  kei mesuda  
//    (http://www.yomogi.sakura.ne.jp/~si)
//--------------------------------------------------------------------------------
// GL::CTexture;   OpenGL Texture bvNX
// 1. Create() / Load() Pixelf[^VXeɍ쐬i̒iKł͓o^͂Ȃj
// 2. SetParameters() ŁCMipmap/g/k/bsO̐ݒ
// 3. Register() ŃrfIɃ[h / UnRegister() ŃrfIォA[h
// 4. Bind()  glBindTexture() / UnBind()  glBindTexture(0)
// 5. DrawPixels()  glDrawPixel()
// 6. CopyTexture() glCopyTexImage2D()
// 7. Update() glTexSubImage*()
// 8. Delete() œo^Pixelf[^j
// 9. Is*()CGet*() ŏQ
//--------------------------------------------------------------------------------
// GL::CTextureManager;   GL::CTexture ̊ǗNX
// t@C̃eNX`񃁃WJȂ悤ɂD
// GL::CSolidModel ŎgpDʏCgKv͖D
//--------------------------------------------------------------------------------
#ifndef _CORE_GLTEXTURE_INCLUDED
#define _CORE_GLTEXTURE_INCLUDED

#include <list>
#include <string>
#include "RGBA.h"
#pragma message ("<< CORE_MESSAGE >>  include GL::CTexture")

#ifndef _MAX_PATH
#define _MAX_PATH 260
#endif



namespace GL {
class CTexture
{
//---------------------------------------------
//  oϐ
//---------------------------------------------
private:
    GLubyte*    m_pData;                    // PixelData
    int         m_iWidth;                   // 
    int         m_iHeight;                  // 
    int         m_iBytes;                   // DatãoCgiGL_ALPHA=1, GL_RGB=3, GL_RGBA=4)
    GLuint      m_uiID;                     // Texture Name (0 Ȃ UnRegisterd)
    std::string m_strFileName;              // FileName
    std::string m_strAlphaName;             // AlphaMapFileName

    bool        m_bMipmap;                  // Mipmap 𐶐邩
    int         m_iMinFilter;               // eNX`ǩvZ@
    int         m_iMagFilter;               // eNX`ǧvZ@
    int         m_iWrapS;                   // eNX`x̃bsO@
    int         m_iWrapT;                   // eNX`ỹbsO@

    int         m_iLog2Width;               // log2(Width)

    GLenum      m_enFormat;                 // Format(m_iBytesɂēŐݒ) (GL_ALPHA / GL_RGB / GL_RGBA)
    GLenum      m_enTarget;                 // GL_TEXTURE_1D / GL_TEXTURE_2D

public:
    CTexture();         // RXgN^
    ~CTexture();        // fXgN^iDelete()Ăяoj

//---------------------------------------------
//  o֐
//---------------------------------------------
public:
    // /j
    bool Create(int width, int height, int bytes, const GLubyte* pixels=NULL);                          // 쐬
    bool Load(const char* strFileName, int bytes);                  // File ǂ݂
    bool Load(const char* strFileName, DWORD dwTransColor);         // File ǂ݂݁iwF߁j
    bool Load(const char* strFileName, const char* strAlphaName);   // File Alpha}bv̓ǂ݂݁i32biteNX`ɑ΂8bitrbg}bv̂݁j
    void Transparent(DWORD dwColor);                                // ߐFw
    void Delete(bool bUnregister=true);                             // jibUnregister=true GRAMo^j

    bool BitBlt(int x, int y, const GLubyte* pixels, int pix_width, int pix_height, int pix_bytes);     // pixel data ̃Rs[

    // ݒ/o^
    void SetParameters(bool bMipmap, bool bMinLinear, bool bMagLinear, bool bRepeatX, bool bRepeatY);   // eNX`@̐ݒio^ÔݗLj
    bool RegParameters(bool bMinLinear, bool bMagLinear, bool bRepeatX, bool bRepeatY);                 // eNX``@̐ݒio^Lj
    bool Register();    // o^irfIɓWJj
    void UnRegister();  // o^irfIォ疕j
	
    void CopyTexture(int x, int y); // Frame buffer eNX`

    // 
    void Update();      // o^ m_pData ̕ύXeNX`ɔf
    
    // glBindTexture()
    void Bind()
    {
        glBindTexture(m_enTarget, m_uiID);
    }
    
    // glBindTexture(0)
    void UnBind()
    {
        glBindTexture(m_enTarget, 0);
    }

    // glRasterPos() -> glDrawPixels()
    void DrawPixels(float x, float y)
    {
        glRasterPos2f(x, y);
        glDrawPixels(m_iWidth, m_iHeight, m_enFormat, GL_UNSIGNED_BYTE, m_pData);
    }

    // glRasterPos() -> glDrawPixels() (`ŃCfbNXwj
    void DrawPixels(float x, float y, int n)
    {
        glRasterPos2f(x, y);
        glDrawPixels(m_iWidth, m_iWidth, m_enFormat, GL_UNSIGNED_BYTE, &(m_pData[(m_iHeight-m_iWidth*(n+1))*m_iWidth*m_iBytes]));
    }

    // glReadPixels()
    void ReadPixels(int x, int y)
    {
        glPixelStorei(GL_PACK_ALIGNMENT ,4);
        glReadPixels(x, y, m_iWidth, m_iHeight, GL_RGBA, GL_UNSIGNED_BYTE, m_pData);
    }

private:
    bool AllocPixelArea(int width, int height, int bytes);  // PixelDatä̗m
    void FreePixelArea();                                   // PixelDatä̗j

//--------------------------------------------------
// Q
//--------------------------------------------------
public:
    // H
    bool IsEmpty()
    {
        return (m_pData == NULL);
    }

    // eNX`t@C̃[hH
    inline bool IsLoaded()
    {
        return (!m_strFileName.empty());
    }

    // eNX`o^Ă邩
    inline bool IsRegistered()
    {
        return (m_uiID != 0);
    }

    // t@C擾
    inline const char* GetFileName()
    {
        return m_strFileName.data();
    }

    // sNZf[^Q
    inline GLubyte* GetPixelData()
    {
        return m_pData;
    }

    // sNZf[^Q(Ww)
    inline GLubyte* GetPixelData(int x, int y)
    {
        int log2 = m_iLog2Width;
        int byte = m_iBytes;
        return &(m_pData[((y << log2) + x) * byte]);
    }

    // 擾
    inline int GetWidth()
    {
        return m_iWidth;
    }

    // 擾
    inline int GetHeight()
    {
        return m_iHeight;
    }

    // F[x擾
    inline int& GetBytes()
    {
        return m_iBytes;
    }

    // OpenGLTextureID擾
    inline GLuint& GetID()
    {
        return m_uiID;
    }
};




//--------------------------------------------------------------------------------
// GL::CTextureManager;   GL::CTexture ̊ǗNX
// Load()Ńt@Cǂݍ݁DCTexture ̃|C^ԂD
// ɊJĂt@C̏ꍇ́CȑOĴƓ|C^ԂD
//--------------------------------------------------------------------------------
class CTextureManager
{
private:
    std::list<CTexture>    m_TextureList;

public:
    CTextureManager();
    ~CTextureManager();

    CTexture* Load(char* strFileName, int byte);                                    // File ǂ݂
    CTexture* Load(char* strFileName, char* strAlphFileName);                       // File ǂ݂(AlphMapt)
    CTexture* Create(int width, int height, int bytes, const GLubyte* pixels=NULL); // 
    CTexture* CheckFile(char* strFileName);                                         // łɊJt@Č
 
    int       RegisterTextures();        // ܂Ƃ߂ăeNX`o^
    void      UnRegisterTextures();      // ܂Ƃ߂ăeNX`o^

private:
    CTexture* New();
};

} // GL

#endif // _CORE_GLTEXTURE_INCLUDED
